<*+CHANGESYM*>
<*+M2EXTENSIONS*>
<*+O2EXTENSIONS*>
<* ALIGNMENT = "8" *>
MODULE Sciter_DOM_Defs;
IMPORT 
  Windows, 
  ti     := Sciter_TIScriptAPI_Defs,
  val    := Sciter_Value_Defs,
  common := Sciter_Common_Defs,
--  rec := Sciter_Behavior_Recs,
  SYSTEM;

TYPE
  HELEMENT* = common.HELEMENT;

TYPE 
  SCDOM_RESULT* = Windows.LONG;

CONST
  SCDOM_OK*                =  0;
  SCDOM_INVALID_HWND*      =  1;
  SCDOM_INVALID_HANDLE*    =  2;
  SCDOM_PASSIVE_HANDLE*    =  3;
  SCDOM_INVALID_PARAMETER* =  4;
  SCDOM_OPERATION_FAILED*  =  5;
  SCDOM_OK_NOT_HANDLED*    = -1;

TYPE 
  ELEMENT_STATE_BITS* = SYSTEM.SET32;

CONST
  STATE_NONE*       = ELEMENT_STATE_BITS   {};
  STATE_LINK*       = ELEMENT_STATE_BITS  {0};
  STATE_HOVER*      = ELEMENT_STATE_BITS  {1};
  STATE_ACTIVE*     = ELEMENT_STATE_BITS  {2};
  STATE_FOCUS*      = ELEMENT_STATE_BITS  {3};
  STATE_VISITED*    = ELEMENT_STATE_BITS  {4};
  STATE_CURRENT*    = ELEMENT_STATE_BITS  {5}; (* current (hot) item *)
  STATE_CHECKED*    = ELEMENT_STATE_BITS  {6}; (* element is checked (or selected) *)
  STATE_DISABLED*   = ELEMENT_STATE_BITS  {7}; (* element is disabled *)
  STATE_READONLY*   = ELEMENT_STATE_BITS  {8}; (* readonly input element *)
  STATE_EXPANDED*   = ELEMENT_STATE_BITS  {9}; (* expanded state - nodes in tree view *)
  STATE_COLLAPSED*  = ELEMENT_STATE_BITS {10}; (* collapsed state - nodes in tree view - mutually exclusive with *)
  STATE_INCOMPLETE* = ELEMENT_STATE_BITS {11}; (* one of fore/back images requested but not delivered *)
  STATE_ANIMATING*  = ELEMENT_STATE_BITS {12}; (* is animating currently *)
  STATE_FOCUSABLE*  = ELEMENT_STATE_BITS {13}; (* will accept focus *)
  STATE_ANCHOR*     = ELEMENT_STATE_BITS {14}; (* anchor in selection (used with current in selects) *)
  STATE_SYNTHETIC*  = ELEMENT_STATE_BITS {15}; (* this is a synthetic element - don't emit it's head/tail *)
  STATE_OWNS_POPUP* = ELEMENT_STATE_BITS {16}; (* this is a synthetic element - don't emit it's head/tail *)
  STATE_TABFOCUS*   = ELEMENT_STATE_BITS {17}; (* focus gained by tab traversal *)
  STATE_EMPTY*      = ELEMENT_STATE_BITS {18}; (* empty - element is empty (text.size() == 0 && subs.size() == 0) if element has behavior attached then the behavior is responsible for the value of this flag.*)
  STATE_BUSY*       = ELEMENT_STATE_BITS {19}; (* busy; loading *)
  STATE_DRAG_OVER*  = ELEMENT_STATE_BITS {20}; (* drag over the block that can accept it (so is current drop target). Flag is    set for the drop target block *)
  STATE_DROP_TARGET*= ELEMENT_STATE_BITS {21}; (* active drop target. *)
  STATE_MOVING*     = ELEMENT_STATE_BITS {22}; (* dragging/moving - the flag is set for the moving block. *)
  STATE_COPYING*    = ELEMENT_STATE_BITS {23}; (* dragging/copying - the flag is set for the copying block. *)
  STATE_DRAG_SOURCE*= ELEMENT_STATE_BITS {24}; (* element that is a drag source. *)
  STATE_DROP_MARKER*= ELEMENT_STATE_BITS {25}; (* element is drop marker *)
  STATE_PRESSED*    = ELEMENT_STATE_BITS {26}; (* pressed - close to active but has wider life span - e.g. in MOUSE_UP it is still on; so behavior can check it in MOUSE_UP to discover CLICK condition. *)                       
  STATE_POPUP*      = ELEMENT_STATE_BITS {27}; (* this element is out of flow - popup *)
  STATE_IS_LTR*     = ELEMENT_STATE_BITS {28}; (* the element or one of its containers has dir=ltr declared *)
  STATE_IS_RTL*     = ELEMENT_STATE_BITS {29}; (* the element or one of its containers has dir=rtl declared *)
                                       

TYPE
  ELEMENT_AREAS* = SYSTEM.SET32;

CONST
  (* - position inside immediate container. *)
  CONTAINER_RELATIVE* = ELEMENT_AREAS {0, 1}; --  3H
  (* - position relative to view - HTMLayout window *)
  VIEW_RELATIVE*      = ELEMENT_AREAS {2};    --  4H;   
  (* content (inner) box *)
  CONTENT_BOX*        = ELEMENT_AREAS {};     --  0H;
  (* content + paddings *)
  PADDING_BOX*        = ELEMENT_AREAS {4};    -- 10H;
  (* content + paddings + border *)
  BORDER_BOX*         = ELEMENT_AREAS {5};    -- 20H;
  (* content + paddings + border + margins  *)
  MARGIN_BOX*         = ELEMENT_AREAS {4, 5}; -- 30H;
  (* relative to content origin - location of background image (if it set no-repeat) *)
  BACK_IMAGE_AREA*    = ELEMENT_AREAS {6};        -- 40H;  
  (* relative to content origin - location of foreground image (if it set no-repeat) *)
  FORE_IMAGE_AREA*    = ELEMENT_AREAS {4, 6}; -- 50H;   
  (* scroll_area - scrollable area in content box  *)
  SCROLLABLE_AREA*    = ELEMENT_AREAS {5, 6}; -- 60H;  


TYPE
  SCITER_SCROLL_FLAGS* = SYSTEM.SET32;

CONST
  SCROLL_TO_TOP* = SCITER_SCROLL_FLAGS {0};
  SCROLL_SMOOTH* = SCITER_SCROLL_FLAGS {4};

TYPE
  SET_ELEMENT_HTML* = Windows.UINT;

CONST
  SIH_REPLACE_CONTENT*     = 0;
  SIH_INSERT_AT_START*     = 1;
  SIH_APPEND_AFTER_LAST*   = 2; 
  SOH_REPLACE*             = 3;
  SOH_INSERT_BEFORE*       = 4;
  SOH_INSERT_AFTER*        = 5; 

CONST 
  CTL_NO             * =  0; (* This dom element has no behavior at all. *)
  CTL_UNKNOWN        * =  1; (* This dom element has behavior but its type is unknown. *)
  CTL_EDIT           * =  2; (* Single line edit box. *)
  CTL_NUMERIC        * =  3; (* Numeric input with optional spin buttons. *)
  CTL_BUTTON         * =  4; (* Command button. *)
  CTL_CHECKBOX       * =  5; (* CheckBox (button). *)
  CTL_RADIO          * =  6; (* OptionBox (button). *)
  CTL_SELECT_SINGLE  * =  7; (* Single select, ListBox or TreeView. *)
  CTL_SELECT_MULTIPLE* =  8; (* Multiselectable select, ListBox or TreeView. *)
  CTL_DD_SELECT      * =  9; (* Dropdown single select. *)
  CTL_TEXTAREA       * = 10; (* Multiline TextBox. *)
  CTL_HTMLAREA       * = 11; (* WYSIWYG HTML editor. *)
  CTL_PASSWORD       * = 12; (* Password input element. *)
  CTL_PROGRESS       * = 13; (* Progress element. *)
  CTL_SLIDER         * = 14; (* Slider input element.   *)
  CTL_DECIMAL        * = 15; (* Decimal number input element. *)
  CTL_CURRENCY       * = 16; (* Currency input element. *)
  CTL_SCROLLBAR      * = 17;
  CTL_HYPERLINK      * = 18;
  CTL_MENUBAR        * = 19;
  CTL_MENU           * = 20;
  CTL_MENUBUTTON     * = 21;
  CTL_CALENDAR       * = 22;
  CTL_DATE           * = 23;
  CTL_TIME           * = 24;
  CTL_FRAME          * = 25;
  CTL_FRAMESET       * = 26;
  CTL_GRAPHICS       * = 27;
  CTL_SPRITE         * = 28;
  CTL_LIST           * = 29;
  CTL_RICHTEXT       * = 30;
  CTL_TOOLTIP        * = 31;
  CTL_HIDDEN         * = 32;
  CTL_URL            * = 33; (* URL input element. *)
  CTL_TOOLBAR        * = 34;
  CTL_FORM           * = 35;

TYPE
  CTL_TYPE* = Windows.UINT;

PROCEDURE ["StdCall"] / Sciter_UseElement*(he: HELEMENT): SCDOM_RESULT;
PROCEDURE ["StdCall"] / Sciter_UnuseElement*(he: HELEMENT): SCDOM_RESULT;
PROCEDURE ["StdCall"] / SciterGetRootElement*(hwnd: Windows.HWND; VAR he: HELEMENT): SCDOM_RESULT;
PROCEDURE ["StdCall"] / SciterGetFocusElement*(hwnd: Windows.HWND; VAR he: HELEMENT): SCDOM_RESULT;
PROCEDURE ["StdCall"] / SciterFindElement*(hwnd: Windows.HWND; pt: Windows.POINT; VAR he: HELEMENT): SCDOM_RESULT;
PROCEDURE ["StdCall"] / SciterGetChildrenCount*(he: HELEMENT; VAR count: Windows.UINT): SCDOM_RESULT;
PROCEDURE ["StdCall"] / SciterGetNthChild*(he: HELEMENT; n: Windows.UINT; VAR he: HELEMENT): SCDOM_RESULT;
PROCEDURE ["StdCall"] / SciterGetParentElement*(he: HELEMENT; VAR parent_he: HELEMENT): SCDOM_RESULT;
PROCEDURE ["StdCall"] / SciterGetElementHtmlCB*(he: HELEMENT; outer: Windows.BOOL; VAR rcv: Windows.PBYTE; rcv_param: Windows.PVOID): SCDOM_RESULT;
PROCEDURE ["StdCall"] / SciterGetElementTextCB*(he: HELEMENT; outer: Windows.BOOL; VAR rcv: Windows.PBYTE; rcv_param: Windows.PVOID): SCDOM_RESULT;
PROCEDURE ["StdCall"] / SciterSetElementText*(he: HELEMENT; utf16: Windows.PWSTR; length: Windows.UINT): SCDOM_RESULT;
PROCEDURE ["StdCall"] / SciterGetAttributeCount*(he: HELEMENT; VAR count: Windows.UINT): SCDOM_RESULT;
PROCEDURE ["StdCall"] / SciterGetNthAttribute*(he: HELEMENT; n: Windows.UINT; VAR name: Windows.PSTR; VAR value: Windows.PWSTR): SCDOM_RESULT;
PROCEDURE ["StdCall"] / SciterSetCapture*(he: HELEMENT): SCDOM_RESULT;
PROCEDURE ["StdCall"] / SciterReleaseCapture*(he: HELEMENT): SCDOM_RESULT;
PROCEDURE ["StdCall"] / SciterGetAttributeByName*(he: HELEMENT; name: Windows.PSTR; VAR value: Windows.PWSTR): SCDOM_RESULT;
PROCEDURE ["StdCall"] / SciterSetAttributeByName*(he: HELEMENT; name: Windows.PSTR; value: Windows.PWSTR): SCDOM_RESULT;
PROCEDURE ["StdCall"] / SciterClearAttributes*(he: HELEMENT): SCDOM_RESULT;
PROCEDURE ["StdCall"] / SciterGetElementIndex*(he: HELEMENT; VAR index: Windows.UINT): SCDOM_RESULT;
PROCEDURE ["StdCall"] / SciterGetElementType*(he: HELEMENT; VAR type: Windows.PSTR): SCDOM_RESULT;
PROCEDURE ["StdCall"] / SciterGetStyleAttribute*(he: HELEMENT; name: Windows.PSTR; VAR value: Windows.PWSTR): SCDOM_RESULT;
PROCEDURE ["StdCall"] / SciterSetStyleAttribute*(he: HELEMENT; name: Windows.PSTR; value: Windows.PWSTR): SCDOM_RESULT;
PROCEDURE ["StdCall"] / SciterGetElementLocation*(he: HELEMENT; VAR location: Windows.RECT; areas: ELEMENT_AREAS): SCDOM_RESULT;
PROCEDURE ["StdCall"] / SciterScrollToView*(he: HELEMENT; SciterScrollFlags: SCITER_SCROLL_FLAGS): SCDOM_RESULT;
PROCEDURE ["StdCall"] / SciterUpdateElement*(he: HELEMENT; doRelayout: Windows.BOOL): SCDOM_RESULT;
PROCEDURE ["StdCall"] / SciterRefreshElementArea*(he: HELEMENT; rc: Windows.RECT): SCDOM_RESULT;
PROCEDURE ["StdCall"] / SciterGetElementHwnd*(he: HELEMENT; VAR hwnd: Windows.HWND; rootWindow: Windows.BOOL): SCDOM_RESULT;
PROCEDURE ["StdCall"] / SciterCombineURL*(he: HELEMENT; szUrlBuffer: Windows.PWSTR; UrlBufferSize: Windows.DWORD): SCDOM_RESULT;

TYPE 
  SciterElementCallback* = PROCEDURE ["StdCall"] (he: HELEMENT; param: Windows.PVOID);

PROCEDURE ["StdCall"] / SciterSelectElements*(he: HELEMENT; CSS_selectors: Windows.PSTR; callback: SciterElementCallback; param: Windows.PVOID): SCDOM_RESULT;
PROCEDURE ["StdCall"] / SciterSelectElementsW*(he: HELEMENT; CSS_selectors: Windows.PWSTR; callback: SciterElementCallback; param: Windows.PVOID): SCDOM_RESULT;
PROCEDURE ["StdCall"] / SciterSelectParent*(he: HELEMENT; selector: Windows.PSTR; depth: Windows.UINT; VAR heFound: HELEMENT): SCDOM_RESULT;
PROCEDURE ["StdCall"] / SciterSelectParentW*(he: HELEMENT; selector: Windows.PWSTR; depth: Windows.UINT; VAR heFound: HELEMENT): SCDOM_RESULT;
PROCEDURE ["StdCall"] / SciterSetElementHtml*(he: HELEMENT; html: Windows.PBYTE; htmlLength: Windows.DWORD; where: SET_ELEMENT_HTML): SCDOM_RESULT;
PROCEDURE ["StdCall"] / SciterGetElementUID*(he: HELEMENT; VAR uid: Windows.UINT): SCDOM_RESULT;
PROCEDURE ["StdCall"] / SciterGetElementByUID*(hwnd: Windows.HWND;  uid: Windows.UINT; VAR he: HELEMENT): SCDOM_RESULT;
PROCEDURE ["StdCall"] / SciterShowPopup*(hePopup: HELEMENT; heAnchor: HELEMENT; placement: Windows.UINT): SCDOM_RESULT;
PROCEDURE ["StdCall"] / SciterShowPopupAt*(hePopup: HELEMENT; pos: Windows.POINT; animate: Windows.BOOL): SCDOM_RESULT;
PROCEDURE ["StdCall"] / SciterHidePopup*(he: HELEMENT): SCDOM_RESULT;
PROCEDURE ["StdCall"] / SciterGetElementState*(he: HELEMENT; VAR pstateBits: ELEMENT_STATE_BITS): SCDOM_RESULT;
PROCEDURE ["StdCall"] / SciterSetElementState*(he: HELEMENT; stateBitsToSet, stateBitsToClear: ELEMENT_STATE_BITS; updateView: Windows.BOOL): SCDOM_RESULT;
PROCEDURE ["StdCall"] / SciterCreateElement*(tagname: Windows.PSTR; textOrNull: Windows.PWSTR; VAR out: HELEMENT): SCDOM_RESULT;
PROCEDURE ["StdCall"] / SciterCloneElement*(he: HELEMENT; VAR out: HELEMENT): SCDOM_RESULT;
PROCEDURE ["StdCall"] / SciterInsertElement*(he: HELEMENT; hparent: HELEMENT; index: Windows.UINT): SCDOM_RESULT;
PROCEDURE ["StdCall"] / SciterDetachElement*(he: HELEMENT);
PROCEDURE ["StdCall"] / SciterSetTimer*(he: HELEMENT; milliseconds: Windows.UINT; VAR timerId: Windows.UINT): SCDOM_RESULT;

PROCEDURE ["StdCall"] / SciterDetachEventHandler*(he: HELEMENT; ep: common.ElementEventProc; tag: Windows.PVOID): SCDOM_RESULT;
PROCEDURE ["StdCall"] / SciterAttachEventHandler*(he: HELEMENT; ep: common.ElementEventProc; tag: Windows.PVOID): SCDOM_RESULT;
PROCEDURE ["StdCall"] / SciterWindowAttachEventHandler*(hwndLayout: Windows.HWND; ep: common.ElementEventProc; tag: Windows.PVOID; subscription: common.EVENT_GROUPS): SCDOM_RESULT;
PROCEDURE ["StdCall"] / SciterWindowDetachEventHandler*(hwndLayout: Windows.HWND; ep: common.ElementEventProc; tag: Windows.PVOID): SCDOM_RESULT;
PROCEDURE ["StdCall"] / SciterSendEvent*(he: HELEMENT; appEventCode: Windows.UINT; heSource: HELEMENT; reason: Windows.UINT; VAR handled: Windows.BOOL): SCDOM_RESULT;
PROCEDURE ["StdCall"] / SciterPostEvent*(he: HELEMENT; appEventCode: Windows.UINT; heSource: HELEMENT; reason: Windows.UINT; VAR handled: Windows.BOOL): SCDOM_RESULT;

TYPE 
  METHOD_PARAMS* = RECORD
  END;

PROCEDURE ["StdCall"] / SciterCallBehaviorMethod*(he: HELEMENT; VAR params: METHOD_PARAMS): SCDOM_RESULT;

TYPE 
  REQUEST_TYPE* = Windows.UINT;

CONST 
  GET_ASYNC * = 0;   (* async GET *)
  POST_ASYNC* = 1;   (* async POST *)
  GET_SYNC  * = 2;   (* synchronous GET  *)
  POST_SYNC * = 3;   (* synchronous POST  *)

TYPE 
  REQUEST_PARAM* = RECORD
    name: Windows.PWSTR;
    value: Windows.PWSTR;
  END;

PROCEDURE ["StdCall"] / SciterRequestElementData*(he: HELEMENT; url: Windows.PWSTR; dataType: Windows.UINT; initiator: HELEMENT): SCDOM_RESULT;
PROCEDURE ["StdCall"] / SciterHttpRequest*( 
				  he: HELEMENT;                     -- element to deliver data 
          url: Windows.PWSTR;               -- url 
          dataType: Windows.UINT;           -- data type, see SciterResourceType.
          requestType: Windows.UINT;        -- one of REQUEST_TYPE values
          VAR requestParams: REQUEST_PARAM; -- parameters 
          nParams: Windows.UINT             -- number of parameters 
          ): SCDOM_RESULT;
PROCEDURE ["StdCall"] / SciterGetScrollInfo*(he: HELEMENT; VAR  scrollPos: Windows.POINT;  VAR viewRect: Windows.RECT; VAR contentSize: Windows.SIZEL): SCDOM_RESULT;
PROCEDURE ["StdCall"] / SciterSetScrollPos*(he: HELEMENT; scrollPos: Windows.POINT; smooth: Windows.BOOL): SCDOM_RESULT;
PROCEDURE ["StdCall"] / SciterGetElementIntrinsicWidths*(he: HELEMENT; VAR MinWidth: Windows.LONG; VAR MaxWidth: Windows.LONG): SCDOM_RESULT;
PROCEDURE ["StdCall"] / SciterGetElementIntrinsicHeight*(he: HELEMENT; forWidth: Windows.LONG; VAR Height: Windows.LONG): SCDOM_RESULT;
PROCEDURE ["StdCall"] / SciterIsElementVisible*(he: HELEMENT; VAR Visible: Windows.BOOL): SCDOM_RESULT;
PROCEDURE ["StdCall"] / SciterIsElementEnabled*(he: HELEMENT; VAR Enabled: Windows.BOOL): SCDOM_RESULT;

TYPE
  ELEMENT_COMPARATOR* = PROCEDURE ["StdCall"] (he1: HELEMENT; he2: HELEMENT; param: Windows.PVOID): Windows.LONG;

PROCEDURE ["StdCall"] / SciterSortElements*(he: HELEMENT; firstIndex: Windows.UINT; lastIndex: Windows.UINT;
                                            cmpFunc: ELEMENT_COMPARATOR; cmpFuncParam: Windows.PVOID): SCDOM_RESULT;
PROCEDURE ["StdCall"] / SciterSwapElements*(he1: HELEMENT; he2: HELEMENT): SCDOM_RESULT;
PROCEDURE ["StdCall"] / SciterTraverseUIEvent*(evt: Windows.UINT; eventCtlStruct: Windows.LPVOID; VAR bOutProcessed: Windows.BOOL): SCDOM_RESULT;
PROCEDURE ["StdCall"] / SciterCallScriptingMethod*(he: HELEMENT; name: Windows.PSTR; VAR argv: val.VALUE; argc: Windows.UINT; VAR retval: val.VALUE): SCDOM_RESULT;
PROCEDURE ["StdCall"] / SciterCallScriptingFunction*(he: HELEMENT; name: Windows.PSTR; VAR argv: val.VALUE; argc: Windows.UINT; VAR retval: val.VALUE): SCDOM_RESULT;
PROCEDURE ["StdCall"] / SciterAttachHwndToElement*(he: HELEMENT; hwnd: Windows.HWND): SCDOM_RESULT;
PROCEDURE ["StdCall"] / SciterControlGetType*(he: HELEMENT; VAR Type: CTL_TYPE): SCDOM_RESULT;
PROCEDURE ["StdCall"] / SciterGetValue*(he: HELEMENT; VAR value: val.VALUE): SCDOM_RESULT;
PROCEDURE ["StdCall"] / SciterSetValue*(he: HELEMENT; VAR value: val.VALUE): SCDOM_RESULT;
PROCEDURE ["StdCall"] / SciterGetExpando*(he: HELEMENT; value: val.VALUE; forceCreation: Windows.BOOL): SCDOM_RESULT;
PROCEDURE ["StdCall"] / SciterGetObject*(he: HELEMENT; VAR value: ti.tiscript_value; forceCreation: Windows.BOOL): SCDOM_RESULT;
PROCEDURE ["StdCall"] / SciterGetElementNamespace*(he: HELEMENT; VAR value: ti.tiscript_value): SCDOM_RESULT;

END Sciter_DOM_Defs.