<*+CHANGESYM*>
<*+M2EXTENSIONS*>
<*+O2EXTENSIONS*>
<* ALIGNMENT = "8" *>
MODULE Sciter_Lite_Defs;

IMPORT
  common := Sciter_Common_Defs,
  Windows;

TYPE
  LITE_CTL* = RECORD
  END;

  SCILITE* = POINTER TO LITE_CTL;

CONST
  SCL_OK                * = 0;
  SCL_INVALID_HANDLE    * = 1;
  SCL_INVALID_FORMAT    * = 2;
  SCL_FILE_NOT_FOUND    * = 3;
  SCL_INVALID_PARAMETER * = 4;
  SCL_INVALID_STATE     * = 5;   (*  attempt to do operation on empty document *)

TYPE
  SCLRESULT * = Windows.UINT;

CONST 
  SC_REFRESH_AREA* = 0AFFH + 020H;
  SC_SET_TIMER*    = 0AFFH + 021H;
  SC_SET_CURSOR*   = 0AFFH + 022H;
  SC_UPDATE_UI*    = 0AFFH + 023H;

TYPE
  PSCN_REFRESH_AREA* = POINTER ["StdCall"] TO SCN_REFRESH_AREA;
  SCN_REFRESH_AREA* = RECORD (common.SCITER_CALLBACK_NOTIFICATION)
    area*: Windows.RECT;             (**< [in] area to refresh.*)
  END;

TYPE
  PSCN_SET_TIMER* = POINTER ["StdCall"] TO SCN_SET_TIMER;
  SCN_SET_TIMER* = RECORD (common.SCITER_CALLBACK_NOTIFICATION)
    timerId*: Windows.PUINT;   (**< [in] id of the timer event.*)
    elapseTime*: Windows.UINT; (**< [in] elapseTime of the timer event, milliseconds. 
                                         If it is 0 then this timer has to be stoped. *)
  END;

TYPE
  PSCN_SET_CURSOR* = POINTER ["StdCall"] TO SCN_SET_CURSOR;
  SCN_SET_CURSOR* = RECORD (common.SCITER_CALLBACK_NOTIFICATION)
    cursorId*: Windows.UINT; (**< [in] id of the cursor, .*)
  END;

PROCEDURE ["StdCall"] / SciliteCreateInstance*(): SCILITE;
PROCEDURE ["StdCall"] / SciliteDestroyInstance*(hLite: SCILITE): SCLRESULT;
PROCEDURE ["StdCall"] / SciliteSetTag*(hLite: SCILITE; tag: Windows.PVOID): SCLRESULT;
PROCEDURE ["StdCall"] / SciliteGetTag*(hLite: SCILITE; VAR tag: Windows.PVOID): SCLRESULT;
PROCEDURE ["StdCall"] / SciliteLoadFromFile*(hLite: SCILITE; path: Windows.PWSTR): SCLRESULT;
PROCEDURE ["StdCall"] / SciliteLoadFromBytes*(hLite: SCILITE; baseURI: Windows.PWSTR; dataptr: Windows.PBYTE; datasize: Windows.UINT): SCLRESULT;
PROCEDURE ["StdCall"] / SciliteReplace*(hLite: SCILITE; hwnd: Windows.HWND; viewX: Windows.LONG; viewY: Windows.LONG; viewWidth: Windows.LONG; viewHeight: Windows.LONG): SCLRESULT;

PROCEDURE ["StdCall"] / SciliteRender*(hLite: SCILITE; hdc: Windows.HDC; 
                                       x,               -- x position of area to render in pixels  
                                       y,               -- y position of area to render in pixels  
                                       sx,              -- width of area to render in pixels  
                                       sy: Windows.LONG -- height of area to render in pixels  
          ): SCLRESULT; 

PROCEDURE ["StdCall"] / SciliteRenderOnBitmap*(hLite: SCILITE; hbmp: Windows.HBITMAP; 
                                               x,                -- x position of area to render  
                                               y,                -- y position of area to render  
                                               sx,               -- width of area to render  
                                               sy: Windows.LONG  -- height of area to render  
          ): SCLRESULT; 


PROCEDURE ["StdCall"] / SciliteSetDataReady*(hLite: SCILITE; url: Windows.PWSTR; data: Windows.PBYTE; dataSize: Windows.DWORD): SCLRESULT;
PROCEDURE ["StdCall"] / SciliteSetDataReadyAsync*(hLite: SCILITE; uri: Windows.PWSTR; data: Windows.PBYTE; dataSize: Windows.DWORD; requestId: Windows.PVOID): SCLRESULT;
PROCEDURE ["StdCall"] / SciliteGetDocumentMinWidth* (hLite: SCILITE; VAR v: Windows.LONG): SCLRESULT;
PROCEDURE ["StdCall"] / SciliteGetDocumentMinHeight*(hLite: SCILITE; VAR v: Windows.LONG): SCLRESULT;
PROCEDURE ["StdCall"] / SciliteSetMediaType*(hLite: SCILITE; mediatype: Windows.PCSTR): SCLRESULT;
PROCEDURE ["StdCall"] / SciliteGetRootElement*(hLite: SCILITE; VAR he: common.HELEMENT): SCLRESULT;
PROCEDURE ["StdCall"] / SciliteFindElement*(hLite: SCILITE; x, y: Windows.LONG; VAR he: common.HELEMENT): SCLRESULT;

--|
--| Callback function type
--|
--| HtmLayout will call it for callbacks defined in sciter.h, e.g. NMHL_ATTACH_BEHAVIOR
--| 
TYPE
  SCILITE_CALLBACK* = PROCEDURE ["StdCall"] (hLite: SCILITE; VAR hdr: common.SCITER_CALLBACK_NOTIFICATION);

PROCEDURE ["StdCall"] / SciliteSetCallback*(hLite: SCILITE; cb: SCILITE_CALLBACK): SCLRESULT;
PROCEDURE ["StdCall"] / SciliteTraverseUIEvent*(hLite: SCILITE; evt: Windows.UINT; eventCtlStruct: Windows.PVOID; VAR bOutProcessed: Windows.BOOL): SCLRESULT;

CONST
  FOCUS_NEXT * = 0;
  FOCUS_PREV * = 1;
  FOCUS_HOME * = 2;
  FOCUS_END  * = 3;

TYPE
  FOCUS_ADVANCE_CMD* = Windows.UINT;

PROCEDURE ["StdCall"] / SciliteAdvanceFocus*(hLite: SCILITE; where: FOCUS_ADVANCE_CMD; VAR Res: Windows.BOOL): SCLRESULT;
PROCEDURE ["StdCall"] / SciliteUpdateView*(hLite: SCILITE): Windows.BOOL;

END Sciter_Lite_Defs.